#include "Dummy.h"

#include <cassert>
#include <QDebug>

#include <vtkObjectFactory.h>
#include <vtkInformation.h>
#include <vtkInformationVector.h>

#include <pqActiveObjects.h>
#include <pqPipelineSource.h>
#include <pqPipelineFilter.h>

vtkStandardNewMacro(Dummy);

Dummy::Dummy()
{
  SetNumberOfInputPorts(3);
}

Dummy::~Dummy()
{}

int Dummy::RequestData(
  vtkInformation *vtkNotUsed(info),
  vtkInformationVector **inputVector,
  vtkInformationVector *outputVector)
{
  pqPipelineFilter* self_pqfilter = qobject_cast<pqPipelineFilter*>(pqActiveObjects::instance().activeSource());
  Q_ASSERT(self_pqfilter);

  for(int i = 0; i < GetNumberOfInputPorts(); ++i)
    qDebug() << self_pqfilter->getInputPortName(i);

  return 1;
}

int Dummy::FillInputPortInformation(int port, vtkInformation* info)
{
  if (port == 0) {
    info->Set(vtkAlgorithm::INPUT_REQUIRED_DATA_TYPE(), "vtkPolyData");
    return 1;
  }
  else if (port == 1) {
    info->Set(vtkAlgorithm::INPUT_REQUIRED_DATA_TYPE(), "vtkPointSet");
    info->Set(vtkAlgorithm::INPUT_IS_OPTIONAL(), 1);
    return 1;
  }
  else if (port == 2) {
    info->Set(vtkAlgorithm::INPUT_REQUIRED_DATA_TYPE(), "vtkPolyData");
    info->Set(vtkAlgorithm::INPUT_IS_OPTIONAL(), 1);
    return 1;
  }

  return 0;
}
